#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <sstream>
#include <math.h>
#include "System.h"
#include "Utility.h"
#include "SNPData.h"
#include "Simulate.h"
#include "RelationshipUtils.h"

double logFreqError(vector< vector<double> > &letterFreq,
		    vector< vector<double> > &errorFunction, 
		    int allele, int pos);
double haploLogFreqIndep(vector< vector<double> > &letterFreq,
			 vector< vector<double> > &errorFunction,
			 vector<int> &alleles, int startPos);
double haploLogFreqIndepNoError(vector< vector<double> > &letterFreq,
				vector<int> &alleles, int startPos);
double haploLogFreq(SNPData &data, int numHaplos,
		    vector< vector<double> > &errorFunction,
		    vector<int> &alleles, int startPos, int idx);
double haploLogFreq(SNPData &data, vector<int> &haplos,
		    vector<int> &exclude,
		    vector< vector<double> > &errorFunction,
		    vector<int> &alleles, int startPos, int idx);
double haploLogFreqNoError(SNPData &data, int numHaplos,
			   vector<int> &alleles, int startPos);
void printFreq(int prevIBD, int IBD, int idx,
	       int chr, SNPData &data, vector<int> &posMap, 
	       int numHaplos,
	       vector< vector<double> > &letterFreq,
	       vector< vector<double> > &errorFunction,
	       vector<int> &allelesA, vector<int> &allelesB, 
	       int blockStart, int winStart, int lastPos, int transPos,
	       int nonIBDstart, int nonIBDend, ostream &os, int idxA, int idxB);
void printFreq(int prevIBD, int IBD, int idx,
	       int chr, SNPData &data, vector<int> &posMap, 
	       vector<int> &haplos,
	       vector< vector<double> > &letterFreq,
	       vector< vector<double> > &errorFunction,
	       vector<int> &allelesA, vector<int> &allelesB, 
	       int blockStart, int winStart, int lastPos, int transPos,
	       int nonIBDstart, int nonIBDend, ostream &os, int idxA, int idxB,
	       vector<int> &excludeA, vector<int> &excludeB);
int countAllelePairsPost(SNPData &fullData, vector<int> &posMap, int numHaplos,
			 int mrcas, int genA, int genB,
			 int idxA, int idxB, int chr, vector< vector<int> > &indicators,
			 vector< vector<double> > &letterFreq,
			 vector< vector<double> > &errorFunction,
			 int snpsBefore, int snpsAfter, ostream &os);
int countAllelePairsPost(SNPData &fullData, vector<int> &posMap, vector<int> &haplos,
			 vector< vector<int> > &excludeHaplos,
			 int mrcas, int genA, int genB,
			 int idxA, int idxB, int chr, vector< vector<int> > &indicators,
			 vector< vector<double> > &letterFreq,
			 vector< vector<double> > &errorFunction,
			 int snpsBefore, int snpsAfter, ostream &os);
int readConfig(istream &configFile, vector<int> &mrcas,
	       vector<int> &gensA, vector<int> &gensB);
