% Finds overlaps between blocks1 and blocks2.
% blocks1 is an n x 2 matrix where the i-th row has the start and end of
% the i-th block. Blocks are non-overlapping and in increasing order of
% starting points (or ending points, since they don't overlap). Similarly
% for blocks2.
% numOverlaps(i) is the number of blocks in blocks2 that overlap the i-th
% block in blocks1.
function numOverlaps = blockOverlapCounts(blocks1, blocks2)
numOverlaps = zeros(size(blocks1, 1), 1);
if isempty(blocks2)
    return
end
idx2 = 1;
for idx1 = 1:size(blocks1, 1),
    while idx2 <= size(blocks2, 1) && blocks2(idx2, 2) < blocks1(idx1, 1),
        idx2 = idx2 + 1;
    end
    while idx2 <= size(blocks2, 1) && blocks2(idx2, 1) <= blocks1(idx1, 2),
        numOverlaps(idx1) = numOverlaps(idx1) + 1;
        idx2 = idx2 + 1;
    end
end