% Computes statistics per degree. 
% pred: classification confusion matrix, one row and one column for each
% rel in classifyRels
function getClassificationStats(pred, classifyRels)

% get the degree of each relationship in the classification
degrees = getRelDegree(classifyRels);
% Replace unrelated with degree 6.
degrees(degrees == 0) = 6;

% Average within degree precision.
avgPrec = zeros(max(degrees), 1);
for d = 1:length(avgPrec),
    avgPrec(d) = mean(diag(pred(degrees == d, degrees == d)));
end
disp(avgPrec);

degreePrec = zeros(max(degrees), max(degrees));
for r = 1:length(classifyRels),
    for d = 1:size(degreePrec, 1),
        degreePrec(degrees(r), d) = degreePrec(degrees(r), d) + sum(pred(r, degrees == d));
    end
end
avgDegreePrec = sum(diag(degreePrec)) / length(classifyRels)

for d = 1:size(degreePrec, 1),
    degreePrec(d, :) = degreePrec(d, :) / sum(degreePrec(d, :));
end

disp(degreePrec);
end