function rels = getDegreeAssumedRels(degrees)

rels1d = {'2_0_0', '1_n1_0', '1_0_n1'};
rels2d = {'2_0_1', '2_1_0', '1_0_0', '1_n1_1', '1_1_n1'};
rels3d = {'2_0_2', '2_2_0', '2_1_1', '1_0_1', '1_n1_2', '1_2_n1'};
rels4d = {'2_0_3', '2_3_0', '2_1_2', '1_0_2', '1_1_1', '1_n1_3', '1_3_n1'};
rels5d = {'2_0_4', '2_4_0', '2_1_3', '2_2_2', '1_0_3', '1_1_2', '1_n1_4', '1_4_n1'};

rels = {};
for d = degrees,
    switch d
        case 0
            rels = [rels, 'unrel'];
        case 1
            rels = [rels, rels1d];
        case 2
            rels = [rels, rels2d];
        case 3
            rels = [rels, rels3d];
        case 4
            rels = [rels, rels4d];
        case 5 
            rels = [rels, rels5d];
        otherwise
            err = MException('MATLAB:incorrectArgument', 'Unexpected degree %d', d);
            throw(err);
    end
end