% Returns all the relationships of the given degrees.
function rels = getDegreeRels(degrees)
rels = {};
for d = degrees,
    if d == 0,
        rels = [rels, 'unrel'];
        continue;
    end
    genA = 0;
    genB = d - 1;
    while genA >= 0 && genB >= 0,
        rels = [rels, strcat('2_', int2str(genA), '_', int2str(genB))];
        genA = genA + 1;
        genB = genB - 1;
    end
    genA = -1;
    genB = d - 1;
    while genA >= -1 && genB >= -1,
        genAstr = strrep(int2str(genA), '-', 'n');
        genBstr = strrep(int2str(genB), '-', 'n');
        rels = [rels, strcat('1_', genAstr, '_', genBstr)];
        genA = genA + 1;
        genB = genB - 1;
    end
end
end