clear all

% Individuals
minIndiv = 1;
maxIndiv = 100;

write = 0;
correct = 1;

% Set
set = 1;
pairPref = 'CEU_TSI';
setPref = strcat(pairPref, '_Set_', int2str(set));

% Directory with likelihoods (eg. Likelihoods/hapmap3_CEU_TSI)
parDir = '..';
likePref = strcat(parDir, '/PrestOut/hapmap3_', pairPref, '/');

trueRels = {'2_0_0', '1_n1_0', '2_0_1', '1_n1_1', '1_0_0', '2_1_1', '1_0_1', '1_1_1', 'unrel'};

% Assumed rels in the order they will be in the output
assumedRels = {'2_0_0', '1_n1_0', '2_0_1', '1_n1_1', '1_0_0', '2_1_1', '1_0_1', '1_1_1', 'MZ', 'HSC', 'unrel'};
% Assumed rels in prest order
assumedRelsPrest = {'2_0_0', '1_0_0', '1_n1_1', '2_0_1', '2_1_1', 'unrel', '1_0_1', '1_1_1', 'HSC', '1_n1_0', 'MZ'};
numCols = length(assumedRels);
assumedRelMap = zeros(numCols, 1);

for r = 1:numCols,
    assumedRelMap(r) = find(strcmp(assumedRelsPrest{r}, assumedRels));
end

if write,
    for r = 1:length(trueRels),
        pairType = strcat('Pair_', trueRels{r});
        for i = minIndiv:maxIndiv,
            pair = strcat(setPref, '_', pairType, '_', int2str(i));
            % A single line of data, one col per relationship.
            likelihoods = zeros(1, numCols);
            for c = 1:22,
                filename = strcat(likePref, setPref, '/', pairType, '/', pair, ...
                    '/', pair, '_chr', int2str(c), '_pruned.logProb');
                
                temp = importdata(filename, '\t', 1);
                likelihoods = likelihoods + temp.data(1, :);
            end
            outFilename = strcat(likePref, setPref, '/', pairType, '/', pair, ...
                '/', pair, '_allChr_pruned.logProb')
            dlmwrite(outFilename, likelihoods, '-append', 'delimiter', '\t', 'newline', 'unix', 'precision', '%.2f');        
        end
    end
end

conf = zeros(length(trueRels), length(assumedRels));
for r = 1:length(trueRels),
    pairType = strcat('Pair_', trueRels{r});
    for i = minIndiv:maxIndiv,
        pair = strcat(setPref, '_', pairType, '_', int2str(i));
        filename = strcat(likePref, setPref, '/', pairType, '/', pair, ...
            '/', pair, '_allChr_pruned.logProb');
        temp = importdata(filename, '\t');
        likelihoods = temp(1, :);
        [maxLike, maxIdx] = max(likelihoods);
        if maxIdx ~= 6 && r == 9,
            disp(filename)
            disp(likelihoods)
        end
        if maxIdx == 9 && correct,
            disp(filename)
            % Find the second best
            likelihoods(maxIdx) = -Inf;
            [maxLike, maxIdx] = max(likelihoods);
        end
        conf(r, assumedRelMap(maxIdx)) = conf(r, assumedRelMap(maxIdx)) + 1;
    end
end
conf
prec = mean(diag(conf(1:length(trueRels), [1:8, 11])))