function degrees = getRelDegree(rels)
degrees = ones(length(rels), 1);
for r = 1:length(rels),
    if strcmp(rels{r}, 'unrel'),
        degrees(r) = 0;
    elseif strcmp(rels{r}, 'distant')
        degrees(r) = -1;
    else
        relStr = textscan(strrep(rels{r}, 'n1', '-1'), '%s %s %s', 'delimiter', '_');
        mrcas = str2double(char(relStr{1}));
        genA = str2double(char(relStr{2}));
        genB = str2double(char(relStr{3}));
        if genA > -1 && genB > -1,
            degrees(r) = degrees(r) + genA + genB;
            if mrcas == 1,
                degrees(r) = degrees(r) + 1;
            end
        elseif genA == -1,
            degrees(r) = degrees(r) + genB;
        else
            degrees(r) = degrees(r) + genA;
        end
    end
end