% Returns the IBD blocks defined by a set of IBD indicators. All positions 
% are assumed to be on the same chromosome. indicators must be a column
% vector or a matrix where the first position of each line is the IBD
% indicator.
function blocks = indicators2Blocks(indicators)
    % I assume I rarely have more than 10 IBD blocks on the same chrom.
    temp = zeros(10, 2);
    numBlocks = 0;
    if ~isempty(indicators),
        last0 = 0;
        for i = 1:size(indicators, 1),
            if indicators(i, 1) > 0 && ...
                    (i == size(indicators, 1) || indicators(i + 1, 1) == 0),
                numBlocks = numBlocks + 1;
                temp(numBlocks, :) = [last0 + 1, i];
            elseif indicators(i, 1) == 0,
                last0 = i;
            end
        end
    end
    blocks = temp(1:numBlocks, :);
end