clear all

% Data from these trueRels and these assumedRels will be loaded.
inDegrees = [0:5];
outDegrees = [0:5];
matDir = 'matFiles/newIbdNewPost/';
%matDir = 'matFiles/phaseErr008/';
numIndiv = 100;
permute = 1;

trueRels = getDegreeRels(inDegrees)
%trueRels = {'2_0_0', '1_n1_0', '2_0_1', '1_n1_1', '1_0_0', '2_1_1', '1_0_1', '1_1_1', 'unrel'};
%trueRels = {'unrel', '2_0_0', '1_n1_0', '2_0_1', '1_n1_1', '1_0_0', '2_1_1'};

% temp = trueRels{3};
% trueRels{3} = trueRels{1};
% trueRels{1} = temp;
% temp = trueRels{5};
% trueRels{5} = trueRels{6};
% trueRels{6} = temp;
% trueRels

assumedRels = getDegreeAssumedRels(outDegrees)
%assumedRels = {'2_0_0', '1_n1_0', '2_0_1', '1_n1_1', '1_0_0', '2_1_1', '1_0_1', '1_1_1', 'unrel'};
%assumedRels = {'unrel', '2_0_0', '1_n1_0', '2_0_1', '1_n1_1', '1_0_0', '2_1_1'};

classifyRelIdx = 1:length(trueRels);
relAssign = 1:length(trueRels);
classifyRels = trueRels;
sets = [1, 2, 3, 4];
numIndivPerSet = [numIndiv, 0, 0, 100];
numIndivTot = sum(numIndivPerSet);

win = 20;
expIbdCutoff = 0.9;
expNonIbdCutoff = 0.2;
expCutoff = 0.5;
countsSuf = strcat('_w', num2str(win), '_i', num2str(expIbdCutoff), ...
    '_n', num2str(expNonIbdCutoff), '_c', num2str(expCutoff));
percent = 10;

filenames = {};
for s = [1,4],
    for din = inDegrees,
        if din == 0,
            inStr = 'unrel';
        else
            inStr = strcat(int2str(din), 'd_all');
        end
        for dout = outDegrees,
            if dout == 0,
                outStr = 'unrel';
            else
                outStr = strcat(int2str(dout), 'd');
            end
            filenames = [filenames, strcat(matDir, 'set', int2str(s), '_indiv1to', ...
                int2str(numIndiv), '_', inStr, '_vs_', outStr, '.mat')];
        end
    end
end 
numCounts = 4; % haplocount features
numBlockStats = 1; % block statistics
numCols = numCounts * length(assumedRels) + numBlockStats * length(assumedRels) + length(assumedRels);
blockStartIdx = numCounts * length(assumedRels) + 1;
likeStartIdx = blockStartIdx + numBlockStats * length(assumedRels);

blockIndices = (blockStartIdx:(likeStartIdx - 1));

% Find the index of "unrel" in the assumedRels, in case we want to
% normalize the likelihoods using that.
unrelIdx = 0;
poIdx = 0;
opIdx = 0;
sibIdx = 0;
for r = 1:length(assumedRels),
    if strcmp(assumedRels{r}, 'unrel')
        unrelIdx = r;
    elseif strcmp(assumedRels{r}, '1_n1_0')
        poIdx = r;
    elseif strcmp(assumedRels{r}, '1_0_n1')
        opIdx = r;
    elseif strcmp(assumedRels{r}, '2_0_0')
        sibIdx = r;
    end
end
if unrelIdx == 0,
    warning('', 'unrel not found in assumed rels')
end

% selected features
% What features will we take from each assumed model?
% Use only likelihoods of first 2 for degree 1
selLikelihoods = setdiff(1:length(assumedRels), [unrelIdx, opIdx]);
selBlocks = setdiff(1:length(assumedRels), [unrelIdx, poIdx, opIdx]);
selPostcounts = setdiff(1:length(assumedRels), [unrelIdx, sibIdx, poIdx, opIdx]);
selCols = [];
for s = selPostcounts,
    selCols = [selCols, (s - 1) * numCounts + [2, 4]];
end
for s = selBlocks,
    selCols = [selCols, (s - 1) * numBlockStats + blockStartIdx - 1 + [1:numBlockStats]];
end
selCols = [selCols, likeStartIdx - 1 + selLikelihoods]

data = loadClassifierData(filenames, trueRels, assumedRels, numIndivPerSet);

% data = zeros(size(data1, 1), 50, size(data1, 3));
% for i = 1:size(data1, 1),
%     data(i, :, :) = data1(i, 1:50, :);
% end
% data(5, :, :) = data1(5, 51:100, :);

haploAidx = 2:4:(blockStartIdx - 1);
haploBidx = 3:4:(blockStartIdx - 1);

for r = 1:size(data, 1),
    % rescale likelihoods and haplocounts
    for i = 1: size(data, 2),
        % Replace 0 haplocounts with 0.5 and normalize them.
        for d = 1:length(haploAidx),
            if data(r, i, haploAidx(d)) == 0 && data(r, i, haploBidx(d)) == 0,
                data(r, i, haploAidx(d)) = 0.5;
                data(r, i, haploBidx(d)) = 0.5;
            end
        end
        %trainData(i, haploAidx) = trainData(i, haploAidx) - trainData(i, haploBidx);
        haploNorm = data(r, i, haploAidx) + data(r, i, haploBidx);
        data(r, i, haploAidx) = data(r, i, haploAidx) ./ haploNorm;
        data(r, i, haploBidx) = data(r, i, haploBidx) ./ haploNorm;
    end
end

if permute,
    %Permute all the data now
    for r = 1:length(trueRels),
        data(r, :, :) = data(r, randperm(numIndivTot), :);
    end
end

confSum = classifyPost2(data, 10, classifyRels, assumedRels, classifyRelIdx, relAssign, selCols);

% if exist('keepData', 'var') ~= 1 || keepData ~= 1,
%     clearvars -except keepData readData
% end

% Various helper variables
%parDir = '/media/My Passport/RelationshipInfer';
%pairPref = 'CEU_TSI';
%countsPref = strcat(parDir, '/PostCounts/hapmap3_', pairPref, '_cleared/');
%likePref = strcat(parDir, '/Likelihoods/hapmap3_', pairPref, '/');
%likeSuf = '_allChr_pruned_5and7';
%distPref = '../BlockGeneticDist/hapmap3_CEU/Pruned/Pair_';
%sizesPath = '../../hapmap/hapmap3/HAPAA/CEU_TSI/CEU_TSI_pruned.chrSizes';

% filenames = {'set1_indiv1to100_5and7_vs_5and7.mat', ...
%     'set2_indiv1to100_5and7_vs_5and7.mat', ...
%     'set4_indiv1to100_5and7_vs_5and7.mat'};
    
% Not all of these sets will be used, they are here so that I avoid
% retyping them.
% rels1 = {'2_0_0', '2_0_1', '2_0_2', '2_0_3', '2_1_1', '2_1_2', ...
%     '2_1_3', '2_2_2', '2_2_3', '2_3_3', ...
%     '1_0_0', '1_0_1', '1_0_2', '1_0_3', '1_1_1', '1_1_2', ...
%     '1_1_3', '1_2_2', '1_2_3', '1_3_3', ...
%     '1_0_n1', '1_n1_0', '1_n1_1', '1_n1_2', '1_n1_3'};
% 
% rels2 = {'2_0_2', '2_1_1', '1_n1_2', '1_0_1'};
% 
% rels3 = {'2_0_3', '2_1_2', '1_n1_3', '1_0_2', '1_1_1'};
% 
% rels4 = {'2_0_0', '2_0_1', '2_0_2', '2_1_1', '1_n1_2', '1_0_1', ...
%     '2_0_3', '2_1_2', '1_n1_3', '1_0_2', '1_1_1', ...
%     '2_2_2', '2_1_3', '1_1_2', '1_0_3'};
% 
% rels5 = {'2_2_2', '2_1_3', '1_1_2', '1_0_3'};

%assumedRels = {'2_1_2', '2_0_3', '2_3_0', '1_n1_3', '1_3_n1', '1_1_1', '1_0_2'};
%{'2_2_2', '2_1_3', '2_0_4', '2_4_0', '1_n1_4', '1_4_n1', '1_1_2', '1_0_3'};
% The loaded data has examples from all classes in trueRels, but we'll only
% use examples from the classes in classifyRels.
% classifyRels = trueRels;
% classifyRelIdx(i) is the index j of the relationship in trueRels such that
% classifyRels(i) == trueRels(j).
% classifyRelIdx = zeros(length(classifyRels), 1);
% for i = 1:length(classifyRels),
%     for j = 1:length(trueRels),
%         if strcmp(classifyRels(i), trueRels(j)),
%             classifyRelIdx(i) = j;
%             break;
%         end
%     end
% end
% sets = [1, 2, 3, 4];

% Rel assign determines which relationships in classifyRels are in which group/class.
% Balanced vs unbalanced
% relAssign = [2, 2, 2, 2, 1, 2, 2, 1];
% Balanced, a little imbalanced, very imbalanced.
% relAssign = [3, 2, 3, 3, 1, 2, 1, 1];
% Degree
% relAssign = [1, 2, 3, 3, 3, 3, 4, 4, 4, 4, 4, 5, 5, 5, 5];
% Exact rel
% relAssign = 1:length(classifyRels);

% numIndiv = maxIndiv - minIndiv + 1;
% number of individuals per set per relationship



% if exist('keepData', 'var') ~= 1 || keepData ~= 1,
%     if exist('readData', 'var') == 1 && readData == 1,
%         data = loadData(pairPref, countsPref, countsSuf, likePref, likeSuf, ...
%             distPref, sizesPath, trueRels, assumedRels, sets, minIndiv, maxIndiv, percent);
%     else
%         data = loadClassifierData(filenames, trueRels, assumedRels, numIndivPerSet);
%     end
% end
