% Reads the true haplocounts for the first numIndiv individuals.
function counts = loadHaploCounts(numIndiv, countsPref, rel)

counts = zeros(numIndiv, 4);
freqAcol = 6;
freqBcol = 7;

for i = 1:numIndiv,
    countFile = strcat(countsPref, rel, ...
        '/pruned/CEU_Pair_', rel, '_', num2str(i), '_w20.haplocounts');
    temp = importdata(countFile, '\t');
    if ~isempty(temp),
        % mean log ratio of freqA and freqB over all transitions
        counts(i, 1) = mean(temp(:, freqAcol) - temp(:, freqBcol));
        counts(i, 2) = sum((temp(:, freqAcol) - temp(:, freqBcol)) < 0) / size(temp, 1);
        counts(i, 3) = sum((temp(:, freqAcol) - temp(:, freqBcol)) > 0) / size(temp, 1);
    else
        counts(i, 1:3) = 0.0;
    end
    counts(i, 4) = size(temp, 1);
end
end