clear all

% Data from these trueRels and these assumedRels will be loaded.
inDegrees = [0:4];
outDegrees = [0:4];
matDir = 'matFiles/newIbdNewPost/';
%matDir = 'matFiles/phaseErr008/';
numIndiv = 100;
permute = 1;

trueRels = getDegreeRels(inDegrees);
trueRels = {'unrel', '2_0_0', '1_n1_0', '2_0_1', '1_n1_1', '1_0_0', '2_1_1', '1_0_1', '1_1_1'};
% temp = trueRels{3};
% trueRels{3} = trueRels{1};
% trueRels{1} = temp;
% temp = trueRels{5};
% trueRels{5} = trueRels{6};
% trueRels{6} = temp;
% trueRels

assumedRels = getDegreeAssumedRels(outDegrees);
assumedRels = {'unrel', '2_0_0', '1_n1_0', '2_0_1', '1_n1_1', '1_0_0', '2_1_1', '1_0_1', '1_1_1'};
classifyRelIdx = 1:length(trueRels);
relAssign = 1:length(trueRels);
classifyRels = trueRels;
sets = [1, 2, 3, 4];
numIndivPerSet = [numIndiv, 0, 0, 0];
numIndivTot = sum(numIndivPerSet);

win = 20;
expIbdCutoff = 0.9;
expNonIbdCutoff = 0.2;
expCutoff = 0.5;
countsSuf = strcat('_w', num2str(win), '_i', num2str(expIbdCutoff), ...
    '_n', num2str(expNonIbdCutoff), '_c', num2str(expCutoff));
percent = 10;

filenames = {};
for s = [1],
    for din = inDegrees,
        if din == 0,
            inStr = 'unrel';
        else
            inStr = strcat(int2str(din), 'd_all');
        end
        for dout = outDegrees,
            if dout == 0,
                outStr = 'unrel';
            else
                outStr = strcat(int2str(dout), 'd');
            end
            filenames = [filenames, strcat(matDir, 'set', int2str(s), '_indiv1to', ...
                int2str(numIndiv), '_', inStr, '_vs_', outStr, '.mat')];
        end
    end
end 
numCounts = 4; % haplocount features
numBlockStats = 1; % block statistics
numCols = numCounts * length(assumedRels) + numBlockStats * length(assumedRels) + length(assumedRels);
blockStartIdx = numCounts * length(assumedRels) + 1;
likeStartIdx = blockStartIdx + numBlockStats * length(assumedRels);

blockIndices = (blockStartIdx:(likeStartIdx - 1));

assumedRelMap = zeros(length(assumedRels), 1);
for r = 1:length(assumedRels),
    assumedRelMap(r) = find(strcmp(assumedRels{r}, trueRels));
end

data = loadClassifierData(filenames, trueRels, assumedRels, numIndivPerSet);
conf = zeros(length(trueRels));

for r = 1:length(trueRels),
    [maxLike, maxIdx] = max(data(r, :, likeStartIdx:end), [], 3);
    classAssign = assumedRelMap(maxIdx);
    for r1 = 1:length(trueRels),
        conf(r, r1) = sum(classAssign == r1);
    end
end
conf
prec = mean(diag(conf))