close all

%countsPref = '../PostCounts/hapmap3_CEU_TSI_Train_vs_CEU_TSI_Test/';
postPref = '../Likelihoods/hapmap3_CEU_TSI_phaseErr002/CEU_TSI_Set_1/';
trueIBDpref = '../TrueIBD/hapmap3_CEU_TSI_phaseErr002/CEU_TSI_Set_1/';
pairPref = 'CEU_TSI_Set_1';
% sizesPath = '../../hapmap/hapmap3/CEU_TSI/CEU_TSI_pruned.chrSizes';
% mapPref = '../../hapmap/hapmap3/CEU_TSI/CEU_TSI_';
% distPref = '../BlockGeneticDist/hapmap3_CEU/Pruned/Pair_';
% countsSuf = '_w20_i0.9_n0.6_c0.5_';

minIndiv = 1;
maxIndiv = 10;
minChr = 1;
maxChr = 22;
numIndiv = maxIndiv - minIndiv + 1;
numChr = maxChr - minChr + 1;
maxTrans = 40 * numIndiv;

styles = {'-b', '-r', '-g', '-m', '-c', '--b', '--r', '--g', '--m', '--c'};

rels3 = {'2_0_3', '2_1_2', '1_n1_3', '1_0_2', '1_1_1', '2_1_1', '2_2_2'};
rels4 = {'2_1_2', '1_n1_3', '1_0_2', '1_1_1', '2_1_1', '2_2_2'};
trueRels = {'2_1_2'};
postRels = rels3;

trueRelTitles = trueRels;
postRelTitles = postRels;
for r = 1:length(trueRels),
    trueRelTitles{r} = strrep(trueRels{r}, '_', ':');
end
for r = 1:length(postRels),
    postRelTitles{r} = strrep(postRels{r}, '_', ':');
end

    
total = zeros(length(trueRels), length(postRels));
correct = zeros(length(trueRels), length(postRels));

ibdCut = 0.9;
cut = 0.5;
for r1 =  1:length(trueRels),
    pairType = strcat('Pair_', trueRels{r1});
    for i = minIndiv:maxIndiv,
        pairName = strcat(pairPref, '_', pairType, '_', int2str(i));
        for c = minChr:maxChr,
            chrName = strcat('chr', int2str(c));
            % Read the true IBD for the unpruned chromosome
            trueIbd = importdata(strcat(trueIBDpref, pairType, '/', pairName, '/', pairName, '_', chrName,'_pruned.trueibd'), '\t');     
            for r2 = 1:length(postRels),
                % Read the posteriors for that chromosome.
                postIbdTemp = importdata(strcat(postPref, pairType, '/', pairName, '/', pairName, '_', chrName, '_pruned_', postRels{r2}, '.postibd'), '\t');
                postIbd = exp(postIbdTemp(:, [1,4,5]));
            
                % Find the posterior IBD positions (those that we predict
                % IBD for sure).
                postIbdPos = find(postIbd(:, 1) > ibdCut & trueIbd(:, 1) == 1);
                if ~isempty(postIbdPos),
                    discCorA = (postIbd(postIbdPos, 2) ./ postIbd(postIbdPos, 1)) > cut;
                    discCorB = (postIbd(postIbdPos, 3) ./ postIbd(postIbdPos, 1)) > cut;
                    correct(r1, r2) = correct(r1, r2) + ...
                        sum(discCorA == trueIbd(postIbdPos, 2)) + ...
                        sum(discCorB == trueIbd(postIbdPos, 3));
                    total(r1, r2) = total(r1, r2) + 2 * length(postIbdPos);
                end
            end
        end
    end
end

disp(postRels);
disp(correct ./ total);