trueIBDpref = '../TrueIBD/hapmap3_CEU/Pair_';
postCountsPref = '../PostCounts/hapmap3_CEU/Pair_';
trueCountsPref = '../HaploCounts/hapmap3_CEU/Pair_';
distPref = '../BlockGeneticDist/hapmap3_CEU/Pruned/Pair_';

rels = {'2_1_2'};
numIndiv = 100;

cutoffs = zeros(22, 1);
for c = 1:22,
    dists = importdata(strcat(distPref, rels{1}, '/Pair_', rels{1}, ...
        '_chr', int2str(c), '_Merged_10000'));
    cutoffs(c) = prctile(dists, 5);
end

trueCounts = loadHaploCounts(numIndiv, trueCountsPref, rels{1});

postCounts = zeros(numIndiv, 4);
chrCol = 4;
startPos = 11;
endPos = 12;
freqAcol = 15;
freqBcol = 16;
expIbdCutoff = 0.9;
expNonIbdCutoff = 0.6;
expCutoff = 0.5;

for i = 1:numIndiv,
    countFile = strcat(postCountsPref, rels{1}, ...
        '/CEU_Pair_', rels{1}, '_', num2str(i), '/CEU_Pair_', rels{1}, ...
        '_', num2str(i), '_w20', ...
        '_i', num2str(expIbdCutoff), '_n', num2str(expNonIbdCutoff), ...
        '_c', num2str(expCutoff), '_', rels{1}, '.postcounts');
    tempStruct = importdata(countFile, '\t', 1);
    temp = tempStruct.data;
    chroms = temp(:, 4);
    selectors = zeros(size(temp, 1), 1);
    for j = 1:size(temp, 1),
        % that might not filter out some blocks at the end of the
        % chromosome
        if (temp(j, 1) == 1 && temp(j, endPos) - temp(j, startPos) > cutoffs(chroms(j))) || ...
                (temp(j, 1) == 0 && j == size(temp, 1)) || ...
                (temp(j, 1) == 0 && temp(j + 1, 1) == 1 && ...
                temp(j, chrCol) == temp(j + 1, chrCol) && ...
                temp(j, endPos) == temp(j + 1, startPos) && ...
                temp(j + 1, endPos) - temp(j + 1, startPos) > cutoffs(chroms(j)))
            selectors(j) = 1;
        end
    end
    sel = temp(selectors == 1, :);
    if ~isempty(sel),
        % mean log ratio of freqA and freqB over all transitions
        postCounts(i, 1) = mean(sel(:, freqAcol) - sel(:, freqBcol));
        postCounts(i, 2) = sum((sel(:, freqAcol) - sel(:, freqBcol)) < 0) / size(sel, 1);
        postCounts(i, 3) = sum((sel(:, freqAcol) - sel(:, freqBcol)) > 0) / size(sel, 1);
    else
        postCounts(i, 1:3) = 0.0;
    end
    postCounts(i, 4) = size(sel, 1);
end

for j = 1:4,
    figure();
    hist([trueCounts(:, j), postCounts(:, j)])
    corrcoef(trueCounts(:, j), postCounts(:, j))
end