clear all

allPost = 1;

allTrueRels = [5];
allAssumedRels = [4];

% Whether the postcounts will be read or not. If this is set to 0, then
% only the likelihoods will be read and the indices of the postcounts and
% blockcounts will be filled with -1's.
readPost = 1;

doInverse = 1;
% Preferrably read only data from one set (?)
set = 4;
indivPerSet = [0, 0, 0, 100];

for trueRel = allTrueRels,
    for assumedRel = allAssumedRels,
        
        % Various helper variables
        parDir = '/media/Data/Shared/RelationshipInfer';
        pairPref = 'CEU_TSI';
        countsPref = strcat(parDir, '/PostCounts/hapmap3_', pairPref, '_cleared/');
        %countsPref = strcat(parDir, '/PostCounts/hapmap3_', pairPref, '_phaseErr008/');
        likePref = strcat(parDir, '/LogProbs/hapmap3_', pairPref, '/');
        %likePref = strcat(parDir, '/LogProbs/hapmap3_', pairPref, '_phaseErr008/');
        ibdPref = strcat(parDir, '/AvgIBD/hapmap3_', pairPref, '/');
        %ibdPref = strcat(parDir, '/AvgIBD/hapmap3_', pairPref, '_phaseErr008/');
        ibdSuf = 'indiv1to100';
        
        if assumedRel == 0,
            likeSuf = '_allChr_pruned_9';
        else
            likeSuf = strcat('_allChr_pruned_', int2str(assumedRel), 'd');
        end
        outputDir = 'matFiles/newIbdNewPost/';
        %outputDir = 'matFiles/phaseErr008/';
        %distPref = '../BlockGeneticDist/hapmap3_CEU/Pruned/Pair_';
        sizesPath = '../../hapmap/hapmap3/HAPAA/CEU_TSI/CEU_TSI_pruned.chrSizes';
        
        rels1d = {'2_0_0', '1_n1_0'};
        rels2d = {'2_0_1', '1_0_0', '1_n1_1'};
        rels3d = {'2_0_2', '2_1_1', '1_n1_2', '1_0_1'};
        
        rels4d = {'2_0_3', '2_1_2', '1_n1_3', '1_0_2', '1_1_1'};
        
        rels5d = {'2_2_2', '2_1_3', '2_0_4', '1_n1_4', '1_1_2', '1_0_3'};
        
        trueRelsId = strcat(int2str(trueRel), 'd');
        switch trueRel
            case 0
                trueRels = {'unrel'};
                trueRelsId = 'unrel';
            case 1
                trueRels = rels1d;
            case 2
                trueRels = rels2d;
            case 3
                trueRels = rels3d;
            case 4
                trueRels = rels4d;
            case 5
                trueRels = rels5d;
            case 6
                trueRels = {'distant'};
                trueRelsId = 'distant';
        end
        
        assumedRelsId = strcat(int2str(assumedRel), 'd');
        if assumedRel ~= trueRel && ~allPost,
            switch assumedRel
                case 0
                    assumedRels = {'unrel'};
                    assumedRelsId = 'unrel';
                case 1
                    assumedRels = {'2_0_0', '1_n1_0', '1_0_n1'};
                case 2
                    assumedRels = {'2_0_1', '2_1_0'};
                case 3
                    assumedRels = {'2_1_1'};
                case 4
                    assumedRels = {'2_1_2'};
                case 5
                    assumedRels = {'2_2_2'};
            end
        else
            switch assumedRel
                case 0
                    assumedRels = {'unrel'};
                    assumedRelsId = 'unrel';
                case 1
                    assumedRels = [rels1d, {'1_0_n1'}];
                case 2
                    assumedRels = [rels2d, {'2_1_0', '1_1_n1'}];
                case 3
                    assumedRels = [rels3d, {'2_2_0', '1_2_n1'}];
                case 4
                    assumedRels = [rels4d, {'2_3_0', '1_3_n1'}];
                case 5
                    assumedRels = [rels5d, {'2_4_0', '1_4_n1'}];
            end
        end
        
        if assumedRel ~= trueRel && assumedRel > 1 && ~allPost,
            assumedRelsId = strcat(assumedRelsId, 'a');
        end
        
        trueRelsId
        assumedRelsId
        trueRels
        assumedRels
        
        minIndiv = 1;
        maxIndiv = 100;
        numIndiv = maxIndiv - minIndiv + 1;
        
        half = ceil(numIndiv / 2);
        numHalf = half - minIndiv + 1;
        
        filename = strcat(outputDir, 'set', int2str(set), '_indiv', int2str(minIndiv), 'to', ...
            int2str(maxIndiv), '_', trueRelsId, '_vs_', assumedRelsId, '.mat')
        inverseFilename = strcat(outputDir, 'set', int2str(set), '_indiv', int2str(minIndiv), 'to', ...
            int2str(maxIndiv), '_', trueRelsId, 'r_vs_', assumedRelsId, '.mat')
        allFilename = strcat(outputDir, 'set', int2str(set), '_indiv', int2str(minIndiv), 'to', ...
            int2str(maxIndiv), '_', trueRelsId, '_all_vs_', assumedRelsId, '.mat')
        halfFilename = strcat(outputDir, 'set', int2str(set), '_indiv', int2str(minIndiv), 'to', ...
            int2str(half), '_', trueRelsId, '_all_vs_', assumedRelsId, '.mat')
        
        win = 20;
        expIbdCutoff = 0.9;
        expNonIbdCutoff = 0.2;
        expCutoff = 0.5;
        countsSuf = strcat('_w', num2str(win), '_i', num2str(expIbdCutoff), ...
            '_n', num2str(expNonIbdCutoff), '_c', num2str(expCutoff));
        percent = 10;
        
        readClassifierData
    end
end