% % Read classifier data from dist. Data should then be saved into a mat file
% % with the saveClassifierData function. The initClassify script can then be
% % called to restore the data and initialize variables used for
% % classification.
% 
% clear all
% 
% % ------------------- Caution: variables to set -------------------------
% % Various helper variables
% parDir = '/media/Data/Shared/RelationshipInfer';
% pairPref = 'CEU_TSI';
% countsPref = strcat(parDir, '/PostCounts/hapmap3_', pairPref, '_cleared/');
% likePref = strcat(parDir, '/LogProbs/hapmap3_', pairPref, '/');
% ibdPref = strcat(parDir, '/AvgIBD/hapmap3_', pairPref, '/');
% ibdSuf = 'indiv1to100';
% likeSuf = '_allChr_pruned_2d';
% outputDir = 'matFiles/newIbd/';
% %distPref = '../BlockGeneticDist/hapmap3_CEU/Pruned/Pair_';
% sizesPath = '../../hapmap/hapmap3/HAPAA/CEU_TSI/CEU_TSI_pruned.chrSizes';
% 
% % Not all of these sets are used, these variables are here so that I avoid
% % retyping them.
% rels1 = {'2_0_0', '2_0_1', '2_0_2', '2_0_3', '2_1_1', '2_1_2', ...
%     '2_1_3', '2_2_2', '2_2_3', '2_3_3', ...
%     '1_0_0', '1_0_1', '1_0_2', '1_0_3', '1_1_1', '1_1_2', ...
%     '1_1_3', '1_2_2', '1_2_3', '1_3_3', ...
%     '1_0_n1', '1_n1_0', '1_n1_1', '1_n1_2', '1_n1_3'};
% 
% rels1d = {'2_0_0', '1_n1_0'};
% rels2d = {'2_0_1', '1_0_0', '1_n1_1'};
% rels3d = {'2_0_2', '2_1_1', '1_n1_2', '1_0_1'};
% 
% rels4d = {'2_0_3', '2_1_2', '1_n1_3', '1_0_2', '1_1_1'};
% 
% rels4 = {'2_0_0', '2_0_1', '2_0_2', '2_1_1', '1_n1_2', '1_0_1', ...
%     '2_0_3', '2_1_2', '1_n1_3', '1_0_2', '1_1_1', ...
%     '2_2_2', '2_1_3', '1_1_2', '1_0_3'};
% 
% rels5d = {'2_2_2', '2_1_3', '2_0_4', '1_n1_4', '1_1_2', '1_0_3'};
% 
% trueRels = rels4d;
% %assumedRels = {'2_0_2', '2_1_1', '2_2_0', '1_n1_2', '1_0_1', '1_2_n1'};
% %assumedRels = {'2_2_2', '2_1_3', '2_0_4', '2_4_0', '1_n1_4', '1_4_n1',
% %'1_1_2', '1_0_3'};
% assumedRels = {'2_0_1', '2_1_0'};%[rels3d, {'2_0_2', '1_2_n1'}];
% %{'2_1_2', '2_0_3', '2_3_0', '1_n1_3', '1_3_n1', '1_1_1', '1_0_2'};
% trueRelsId = '4d';
% assumedRelsId = '2da';
% 
% % Whether the postcounts will be read or not. If this is set to 0, then
% % only the likelihoods will be read and the indices of the postcounts and
% % blockcounts will be filled with -1's.
% readPost = 1;
% 
% doInverse = 1;
% 
% % Preferrably read only data from one set (?)
% set = 1;
% 
% minIndiv = 1;
% maxIndiv = 100;
% numIndiv = maxIndiv - minIndiv + 1;
% 
% half = ceil(numIndiv / 2);
% numHalf = half - minIndiv + 1;
% 
% filename = strcat(outputDir, 'set', int2str(set), '_indiv', int2str(minIndiv), 'to', ...
%     int2str(maxIndiv), '_', trueRelsId, '_vs_', assumedRelsId, '.mat');
% inverseFilename = strcat(outputDir, 'set', int2str(set), '_indiv', int2str(minIndiv), 'to', ...
%     int2str(maxIndiv), '_', trueRelsId, 'r_vs_', assumedRelsId, '.mat');
% allFilename = strcat(outputDir, 'set', int2str(set), '_indiv', int2str(minIndiv), 'to', ...
%     int2str(maxIndiv), '_', trueRelsId, '_all_vs_', assumedRelsId, '.mat');
% halfFilename = strcat(outputDir, 'set', int2str(set), '_indiv', int2str(minIndiv), 'to', ...
%     int2str(half), '_', trueRelsId, '_all_vs_', assumedRelsId, '.mat');
% 
% win = 20;
% expIbdCutoff = 0.9;
% expNonIbdCutoff = 0.2;
% expCutoff = 0.5;
% countsSuf = strcat('_w', num2str(win), '_i', num2str(expIbdCutoff), ...
%     '_n', num2str(expNonIbdCutoff), '_c', num2str(expCutoff));
% percent = 10;

% ------------------- End of variables to set --------------------------

cutoffFile = 'cutoffs.mat';
data = loadData(pairPref, countsPref, countsSuf, likePref, likeSuf, ...
    cutoffFile, ibdPref, ibdSuf, sizesPath, trueRels, assumedRels, set, ...
    minIndiv, maxIndiv, percent, readPost);

saveClassifierData(filename, trueRels, assumedRels, set, minIndiv, maxIndiv, data);

if doInverse == 1,
    inverseRels = getInverseRels(trueRels);
    newRels = {};
    for r = 1:length(inverseRels),
        found = 0;
        for r1 = 1:length(trueRels),
            if strcmp(inverseRels{r}, trueRels{r1}),
                found = 1;
                break;
            end
        end
        if ~found,
            newRels = [newRels, inverseRels{r}];
        end
    end
    if ~isempty(newRels),
        allRels = [trueRels, newRels];
        inverseData = invertData(data, newRels, trueRels, assumedRels);
        
        saveClassifierData(inverseFilename, newRels, assumedRels, set, minIndiv, maxIndiv, inverseData);
        
        allData = loadClassifierData({filename, inverseFilename}, allRels, assumedRels, indivPerSet);
        saveClassifierData(allFilename, allRels, assumedRels, set, minIndiv, maxIndiv, allData);
        
        halfData = zeros(size(allData, 1), numHalf, size(allData, 3));
        halfData(1:length(trueRels), :, :) = allData(1:length(trueRels), 1:half, :);
        halfData((length(trueRels) + 1):size(allData, 1), :, :) = ...
            allData((length(trueRels) + 1):size(allData, 1), (half + 1):maxIndiv, :);
        saveClassifierData(halfFilename, allRels, assumedRels, set, minIndiv, half, halfData);
    end
end