clear all

% ----------------------- Variables to set -------------------------
% Various helper variables
pop = 'ASW';
step = 4;

% Whether to read the data for a specific degree or the "classify-degree"
% data (if class <= 0).
class = 4;

% Suffix of Likelihoods, PostCounts, and AvgIBD subdirs.
suf = '_switch001';
outDir = strcat('matFiles/hapmap3/', pop, '/');

% Only needed if we read the degree files (class <= 0)
ibdPairSuf = '';

% Whether the postcounts will be read or not. If this is set to 0, then
% only the likelihoods will be read and the indices of the postcounts and
% blockcounts will be filled with -1's.
readPost = 1;

% Combine log probs
combine = 0;
% Load data or not (we might just want to combine the log probs)
load = 1;

% All pairs or just the degree pairs
allPairs = 1;

% ------------------- Variables you might want to set ---------------
hapmapParDir = strcat('../../hapmap/hapmap3/HAPAA/full/', pop);

% ------------------- End of variables to set --------------------------

binPref = strcat('hapmap3_full_', pop, '_poly_hw_Pruned_1_in_', int2str(step));
parDir = '/media/Data/Shared/RelationshipInfer';
countsPref = strcat(parDir, '/PostCounts/hapmap3_full/', binPref, suf)
likePref = strcat(parDir, '/Likelihoods/hapmap3_full/', binPref, suf)
ibdPref = strcat(parDir, '/AvgIBD/hapmap3_full/', binPref, suf);
sizesPath = strcat(hapmapParDir, '/', binPref, '.chrSizes');

if class <= 0,
    filename = strcat(outDir, binPref, '_ibd03_degree.mat');
    ibdSuf = '_ibd03';
    assumedRels = degreeClassificationRels();
    likeSuf = {'_5', '_1'};%{'_5', '_8', '_9', '_1d', '_2d'};
    pairPath = strcat(hapmapParDir, '/', binPref, '_ibd03', ...
        ibdPairSuf, '.pairs');
else
    if allPairs,
        filename = strcat(outDir, binPref, '_ibd03', ibdPairSuf, '_all_vs_', ...
            int2str(class), 'd.mat');
    else
        filename = strcat(outDir, binPref, '_ibd03', ibdPairSuf, ...
            '_', int2str(class), 'd_vs_', ...
            int2str(class), 'd.mat');
    end
    assumedRels = getDegreeAssumedRels([class,0]);
    if class == 1,
        likeSuf = {'_5', '_1'};%{'_5', '_9', '_8', '_1d'}; 
    else
        likeSuf = {'_5', '_8', '_9', strcat('_', int2str(class), 'd')};
    end
    combinedLikeSuf = strcat('_', int2str(class), 'd');
    if allPairs,
        pairPath = strcat(hapmapParDir, '/', binPref, '_ibd03', ...
            ibdPairSuf, '.pairs');
        ibdSuf = '_ibd03';
    else
        pairPath = strcat(hapmapParDir, '/', binPref, '_ibd03_', ...
            int2str(class), 'd.pairs');
        %pairPath = strcat(hapmapParDir, '/', binPref, '_ibd03_4d.pairs');
        ibdSuf = strcat('_ibd03_', int2str(class), 'd');
        %ibdSuf = strcat('_ibd03_4d');
    end
end
[id1, idx1, id2, idx2, ibd] = textread(pairPath, '%s %d %s %d %f', 'delimiter', '\t');
pairs = [idx1 idx2];

win = 20;
expIbdCutoff = 0.9;
expNonIbdCutoff = 0.2;
expCutoff = 0.5;
countsSuf = strcat('_w', num2str(win), '_i', num2str(expIbdCutoff), ...
    '_n', num2str(expNonIbdCutoff), '_c', num2str(expCutoff));
percent = 10;

cutoffFile = 'cutoffs.mat';
if combine && class > 0, 
    combineHapMapLogProbFiles(pairs, likePref, binPref, likeSuf, combinedLikeSuf, assumedRels);
end
if load,
    if combine,
        loadLikeSuf = likeSuf;
    else
        loadLikeSuf = {combinedLikeSuf};
    end
    data = loadHapMapData(binPref, countsPref, countsSuf, likePref, loadLikeSuf, ...
        ibdPref, ibdSuf, cutoffFile, sizesPath, pairs, assumedRels, ...
        percent, readPost, ~combine);
    saveHapMapData(filename, assumedRels, id1, idx1, id2, idx2, data);
end

